import * as puppeteer from 'puppeteer';
import Generic from './Generic';
import { Puth } from '../Server';
import PuthContextPlugin from './PuthContextPlugin';
declare class Context extends Generic {
    private readonly id;
    private readonly type;
    private readonly puth;
    private options;
    private plugins;
    private instance;
    private expectations;
    private eventFunctions;
    constructor(puth: Puth, options?: any);
    setup(): Promise<void>;
    connectBrowser(options: any): Promise<puppeteer.Browser>;
    createBrowser(options?: {}): Promise<puppeteer.Browser | undefined>;
    destroy(): Promise<boolean>;
    _trackPage(page: any): Promise<void>;
    registerEventListenerOn(object: any, event: any, func: any): void;
    _cleanPage(page: any): Promise<void>;
    fail(): void;
    shouldSnapshot(): boolean;
    call(packet: any): Promise<any>;
    handleReturnValue(action: any, returnValue: any, expectation?: any): Promise<any>;
    resolveReturnValue(action: any, returnValue: any, expectation?: any): any;
    get(action: any): Promise<{
        type: string;
        value: any;
    } | {
        type: string;
        code: string;
        message: string;
    }>;
    set(action: any): Promise<true | {
        type: string;
        code: string;
        message: string;
    }>;
    delete(action: any): Promise<{
        type: string;
        code: string;
        message: string;
    } | undefined>;
    getExpectation(name: any): any;
    resolveOn(representation: any): Context | any;
    resolveIfCached(representation: any): any;
    getId(): string;
    getType(): string;
    serialize(): {
        id: string;
        type: string;
    };
    getTest(): string | undefined;
    getGroup(): string | undefined;
    getPuth(): Puth;
    getPlugins(): PuthContextPlugin[];
}
export default Context;
